unit Store_Internal;

interface
uses System.SysUtils
{$REGION '<TESTME>'}      {$IFDEF TESTME}
  ,TestMe,TestMe_Types
  ,TestCodeType,TestCodeLevelUnits
{$ENDIF}  {$ENDREGION}
;


type
  TClassPublic = class
  private
{$REGION '<TESTME>'}      {$IFDEF TESTME}
    class var F_pIndexApp,F_pIndexUnit,F_pIndexClass:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
{$ENDIF}  {$ENDREGION}
  private
   ClassPublic_Pivate_Var:Integer;
   function ClassPublic_Pivate_Method(iA,iB:integer):Integer;
  protected
   ClassPublic_Protected_Var:Integer;
   function ClassPublic_Protected_Method(iA,iB:integer):Integer;
  public
   ClassPublic_Public_Var:Integer;
   function ClassPublic_Public_Method(iA,iB:integer):Integer;
  end;

var
  L_ClassPublic: TClassPublic;


// =====================================
//         TEST Visibility
// =====================================

var UnitPublic_Var:Integer;
function UnitPublic_Method(iA,iB:integer):Integer;




implementation


 type
  TClassPrivate = class
{$REGION '<TESTME>'}      {$IFDEF TESTME}
  private
    class var F_pIndexApp,F_pIndexUnit,F_pIndexClass:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
{$ENDIF}  {$ENDREGION}
  private
   ClassPrivate_Pivate_Var:Integer;
   function ClassPrivate_Pivate_Method(iA,iB:integer):Integer;
  protected
   ClassPrivate_Protected_Var:Integer;
   function ClassPrivate_Protected_Method(iA,iB:integer):Integer;
  public
   ClassPrivate_Public_Var:Integer;
   function ClassPrivate_Public_Method(iA,iB:integer):Integer;
  end;

// Variable Private
var UnitPrivate_Var:Integer;
   L_ClassPrivate:TClassPrivate;


function UnitPrivate_Method(iA,iB:integer):Integer;
begin
 result:=iA+iB;
 UnitPrivate_Var:=Result;
end;

//  Public
function UnitPublic_Method(iA,iB:integer):Integer;
begin
 result:=iA+iB;
 UnitPublic_Var:=Result;
end;


{ TClassPrivate }

function TClassPrivate.ClassPrivate_Pivate_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPrivate_Pivate_Var:=Result;
end;

function TClassPrivate.ClassPrivate_Protected_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPrivate_Protected_Var:=Result;
end;

function TClassPrivate.ClassPrivate_Public_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPrivate_Public_Var:=Result;
end;


function TClassPublic.ClassPublic_Pivate_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPublic_Pivate_Var:=Result;
end;

function TClassPublic.ClassPublic_Protected_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPublic_Protected_Var:=Result;
end;

function TClassPublic.ClassPublic_Public_Method(iA, iB: integer): Integer;
begin
 result:=iA+iB;
 ClassPublic_Public_Var:=Result;
end;


{$REGION '<TESTME>'}      {$IFDEF TESTME}
type
   TTestMethod = (
   tmCreate
   ,tmFree

   ,tmUnitPublic_Var
   ,tmUnitPublic_VarMethod
   ,tmUnitPrivate_Var
   ,tmUnitPrivate_Method

   ,tmClassPublic_Pivate_Var
   ,tmClassPublic_Pivate_Method
   ,tmClassPublic_Protected_Var
   ,tmClassPublic_Protected_Method
   ,tmClassPublic_Public_Var
   ,tmClassPublic_Public_Method

   ,tmClassPrivate_Pivate_Var
   ,tmClassPrivate_Pivate_Method
   ,tmClassPrivate_Protected_Var
   ,tmClassPrivate_Protected_Method
   ,tmClassPrivate_Public_Var
   ,tmClassPrivate_Public_Method

    );


class procedure TClassPrivate._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then Exit;

 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass,F_pIndexUnit,F_pIndexApp) then exit; // Set position
   IRegisterMethod(tmCreate  ,'tmCreate','',pAddOneEmptyParam,0 );// Test methods
   IRegisterMethod(tmFree    ,'tmFree',''  ,pAddOneEmptyParam,MAX_POS_TESTMETHOD );// Test methods

   IRegisterMethod(tmUnitPrivate_Var  ,'tmUnitPrivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmUnitPrivate_Method  ,'tmUnitPrivate_Method','',pAddOneEmptyParam );// Test methods

   IRegisterMethod(tmClassPrivate_Pivate_Var  ,'tmClassPrivate_Pivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Pivate_Method  ,'tmClassPrivate_Pivate_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Protected_Var  ,'tmClassPrivate_Protected_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Protected_Method  ,'tmClassPrivate_Protected_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Public_Var  ,'tmClassPrivate_Public_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPrivate_Public_Method  ,'tmClassPrivate_Public_Method','',pAddOneEmptyParam );// Test methods
 end;
end;

class function TClassPrivate._TestMethods(
  IMethod: IRunMethodParam): TTestResultParam;
begin
 Result:=trErrRegister;
 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmCreate:
          begin
           if L_ClassPrivate=nil then begin
              L_ClassPrivate:=TClassPrivate.Create;
               result:=trOk;
           end else
               result:=trError;
          end;
   tmFree:
          begin
           if L_ClassPrivate<>nil then begin
             FreeAndNil(L_ClassPrivate);
             result:=trOk;
           end else
               result:=trError;
          end;
   tmUnitPrivate_Var,tmUnitPrivate_Method
          :begin
              UnitPrivate_Method(2,2);
              if UnitPrivate_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPrivate_Pivate_Var,tmClassPrivate_Pivate_Method
          :begin
              L_ClassPrivate.ClassPrivate_Pivate_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Pivate_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPrivate_Protected_Var,tmClassPrivate_Protected_Method
          :begin
              L_ClassPrivate.ClassPrivate_Protected_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Protected_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPrivate_Public_Var,tmClassPrivate_Public_Method
          :begin
              L_ClassPrivate.ClassPrivate_Public_Method(2,2);
              if L_ClassPrivate.ClassPrivate_Public_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
 end; // case
end;


class procedure TClassPublic._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then Exit;

 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass,F_pIndexUnit,F_pIndexApp) then exit; // Set position
   IRegisterMethod(tmCreate  ,'tmCreate','',pAddOneEmptyParam,0 );// Test methods
   IRegisterMethod(tmFree    ,'tmFree',''  ,pAddOneEmptyParam,MAX_POS_TESTMETHOD );// Test methods

   IRegisterMethod(tmUnitPublic_Var  ,'tmUnitPublic_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmUnitPublic_VarMethod  ,'tmUnitPublic_VarMethod','',pAddOneEmptyParam );// Test methods

   IRegisterMethod(tmClassPublic_Pivate_Var  ,'tmClassPublic_Pivate_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Pivate_Method  ,'tmClassPublic_Pivate_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Protected_Var  ,'tmClassPublic_Protected_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Protected_Method  ,'tmClassPublic_Protected_Method','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Public_Var  ,'tmClassPublic_Public_Var','',pAddOneEmptyParam );// Test methods
   IRegisterMethod(tmClassPublic_Public_Method  ,'tmClassPublic_Public_Method','',pAddOneEmptyParam );// Test methods

 end; //withend;
end;

class function TClassPublic._TestMethods(IMethod: IRunMethodParam): TTestResultParam;
begin
 Result:=trErrRegister;
 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmCreate:
          begin
           if L_ClassPublic=nil then begin
              L_ClassPublic:=TClassPublic.Create;
               result:=trOk;
           end else
               result:=trError;
          end;
   tmFree:
          begin
           if L_ClassPublic<>nil then begin
             FreeAndNil(L_ClassPublic);
             result:=trOk;
           end else
               result:=trError;
          end;
   tmUnitPublic_Var,tmUnitPublic_VarMethod
          :begin
              UnitPublic_Method(2,2);
              if UnitPublic_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Pivate_Var,tmClassPublic_Pivate_Method
          :begin
              L_ClassPublic.ClassPublic_Pivate_Method(2,2);
              if L_ClassPublic.ClassPublic_Pivate_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Protected_Var,tmClassPublic_Protected_Method
          :begin
              L_ClassPublic.ClassPublic_Protected_Method(2,2);
              if L_ClassPublic.ClassPublic_Protected_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
   tmClassPublic_Public_Var,tmClassPublic_Public_Method
          :begin
              L_ClassPublic.ClassPublic_Public_Method(2,2);
              if L_ClassPublic.ClassPublic_Public_Var=4 then
               result:=trOk
              else
               result:=trError;
           end;
  end; // case

end;


initialization
   if GetTestMe.bIsTestCode then begin
     with GetTestMe.ITestCode do begin
       TClassPublic.F_pIndexApp:=IRegisterApplication( hInstance);
       TClassPublic.F_pIndexUnit:=IRegisterUnit(ltApplication,'Store_Internal','Store TestCode in INternal file');
       TClassPublic.F_pIndexClass := IRegisterClass(TClassPublic._RegisterMethod,TClassPublic._TestMethods,'TClassPublic','Test access visibility Class');

       TClassPrivate.F_pIndexUnit:=TClassPublic.F_pIndexUnit;
       TClassPrivate.F_pIndexClass := IRegisterClass(TClassPrivate._RegisterMethod,TClassPrivate._TestMethods,'TClassPrivate','Test access private  Class');

     end;
   end;
{$ENDIF}  {$ENDREGION}



end.
