unit frmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls
{$IFDEF TESTME}
   ,TestMe,TestMe_Types
   ,TestCodeType, TestCodeLevelUnits
 {$ENDIF}
  ;

type
  TForm1 = class(TForm)
    lbl_1: TLabel;
  private
   {$IFDEF TESTME}
     private
       class var F_pIndexClass:TPIndexValue;
       class Procedure _RegisterMethod;
       class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
   {$ENDIF}
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{ TForm1 }

{$IFDEF TESTME}

  type
   TTestMethod = (
     // test normal invoce
      tmInvoce_CreateOk
     ,tmInvoce_Fill
     ,tmInvoce_Send
     ,tmInvoce_Recive
     ,tmInvoce_Finalize
     // test bad invoce
     ,tmInvoce_CreateBad
     ,tmInvoce_Annulment

     );



class procedure TForm1._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then Exit;
 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass) then exit; // Set position
  // Normal Invoce
   IRegisterMethodList([tmInvoce_CreateOk,tmInvoce_Fill,tmInvoce_Send,tmInvoce_Recive,tmInvoce_Finalize],'tmInvoce_CreateOk,tmInvoce_Fill,tmInvoce_Send,tmInvoce_Recive,tmInvoce_Finalize');
   IRegisterMethodList([tmInvoce_CreateBad,tmInvoce_Annulment],'tmInvoce_CreateBad,tmInvoce_Annulment');
 end; //with

end;

class function TForm1._TestMethods(IMethod: IRunMethodParam): TTestResultParam;
begin
  case TTestMethod(IMethod.IGetNumParamUser)  of
     // test normal invoce
    tmInvoce_CreateOk
     :begin
        Result:=trUnknowResult;
      end;
    tmInvoce_Fill
     :begin
        Result:=trUnknowResult;
      end;
    tmInvoce_Send
     :begin
        Result:=trUnknowResult;

      end;
    tmInvoce_Recive
     :begin
        Result:=trUnknowResult;

      end;
    tmInvoce_Finalize
     :begin
        Result:=trUnknowResult;

      end;
     // test bad invoce
    tmInvoce_CreateBad
     :begin
        Result:=trUnknowResult;

      end;
    tmInvoce_Annulment
     :begin
        Result:=trUnknowResult;

      end;
  end; // cas
end;


initialization
  if GetTestMe.bIsTestCode then begin
     with GetTestMe.ITestCode do begin
        TForm1.F_pIndexClass := IRegisterClass(TForm1._RegisterMethod,TForm1._TestMethods,'TForm1','Test many reg methods');
     end;
  end;

{$ENDIF}

end.
