unit frmMainCalc;
 {$IfNDef TestME}
   Set in project conditional defines - TESTME
 {$ENDIF}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics,
  Controls, Forms, Dialogs
  ,  Calculator, Buttons, StdCtrls, Spin

  ;

type
  TfMainCalc = class(TForm)
    se_1: TSpinEdit;
    se_2: TSpinEdit;
    lbl_1: TLabel;
    lbl_Res: TLabel;
    btn_Plus: TSpeedButton;
    btn_Minus: TSpeedButton;
    btn_Mul: TSpeedButton;
    btn_Div: TSpeedButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btn_PlusClick(Sender: TObject);
    procedure btn_MinusClick(Sender: TObject);
    procedure btn_MulClick(Sender: TObject);
    procedure btn_DivClick(Sender: TObject);
  private
    F_oCalc:TCalc;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fMainCalc: TfMainCalc;

implementation

{$R *.dfm}

procedure TfMainCalc.btn_DivClick(Sender: TObject);
begin
 F_oCalc.Value:=se_1.Value;
 F_oCalc.OpDiv(se_2.Value);
 lbl_Res.Caption:=IntToStr(F_oCalc.Value);

end;

procedure TfMainCalc.btn_MinusClick(Sender: TObject);
begin
 F_oCalc.Value:=se_1.Value;
 F_oCalc.OpMinus(se_2.Value);
 lbl_Res.Caption:=IntToStr(F_oCalc.Value);

end;

procedure TfMainCalc.btn_MulClick(Sender: TObject);
begin
 F_oCalc.Value:=se_1.Value;
 F_oCalc.OpMul(se_2.Value);
 lbl_Res.Caption:=IntToStr(F_oCalc.Value);

end;

procedure TfMainCalc.btn_PlusClick(Sender: TObject);
begin
 F_oCalc.Value:=se_1.Value;
 F_oCalc.OpPlus(se_2.Value);
 lbl_Res.Caption:=IntToStr(F_oCalc.Value);
end;

procedure TfMainCalc.FormCreate(Sender: TObject);
begin
 F_oCalc:=TCalc.Create;
end;

procedure TfMainCalc.FormDestroy(Sender: TObject);
begin
 F_oCalc.Free;
end;

end.
