unit Unit2;
 {$IFNDEF TestSEND}
   set define condition - TestSEND
 {$ENDIF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Samples.Spin;

type
  TForm2 = class(TForm)
    se_1: TSpinEdit;
    btn_Run: TButton;
    lbl_1: TLabel;
    edt_PID: TEdit;
    lbl_2: TLabel;
    procedure btn_RunClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation
 uses TestMe,TestMe_Types ;

{$R *.dfm}

 type
 TOneThread=class(tthread)
    F_iNum:Integer;
   protected
   procedure execute; override;
 end;

var L_pTestMe:PTRecITestMe;

procedure TForm2.FormCreate(Sender: TObject);
begin
 L_pTestMe:=GetTestMe;
  edt_PID.Text:=IntToStr(GetCurrentProcessId);
 Caption:='PID: '+ edt_PID.Text;
end;

 type
  TArrTH=array of TOneThread;

procedure TForm2.btn_RunClick(Sender: TObject);
 var
 i:Integer;
 arr:TArrTH;
begin
  if not L_pTestMe.bIsTestSend then begin
    ShowMessage('No interface ITestSend');
    Exit;
  end;

 if se_1.Value<1 then Exit;

 SetLength(arr,se_1.Value);
 for I := 0 to se_1.Value-1 do begin
   arr[i]:=TOneThread.Create(True);
   arr[i].FreeOnTerminate:=True;
   arr[i].F_iNum:=i;
 end;
 for I := 0 to se_1.Value-1 do
      arr[i].Resume;

 SetLength(arr,0);
end;

{ TOneThread }

procedure TOneThread.execute;
begin
  inherited;
  Sleep(100);
  L_pTestMe.ITestSend.Info('1-THREAD -'+IntToStr(GetCurrentThreadId),GetCurrentThreadId,F_iNum);
  Sleep(100);
  L_pTestMe.ITestSend.Info('2-THREAD -'+IntToStr(GetCurrentThreadId),GetCurrentThreadId,F_iNum);
  Sleep(100);
  L_pTestMe.ITestSend.Info('3-THREAD -'+IntToStr(GetCurrentThreadId),GetCurrentThreadId,F_iNum);

end;


end.
