// JCL_DEBUG_EXPERT_GENERATEJDBG OFF
// JCL_DEBUG_EXPERT_INSERTJDBG OFF
// JCL_DEBUG_EXPERT_DELETEMAPFILE OFF
library DLLTestSend;
 {$IFNDEF TestSEND}
   set define condition - TestSEND
 {$ENDIF}


{ Important note about DLL memory management: ShareMem must be the
  first unit in your library's USES clause AND your project's (select
  Project-View Source) USES clause if your DLL exports any procedures or
  functions that pass strings as parameters or function results. This
  applies to all strings passed to and from your DLL--even those that
  are nested in records and classes. ShareMem is the interface unit to
  the BORLNDMM.DLL shared memory manager, which must be deployed along
  with your DLL. To avoid using BORLNDMM.DLL, pass string information
  using PChar or ShortString parameters. }

uses
  System.SysUtils,
  System.Classes
  ,TestMe,testMe_Types
  ,TestSendType

  ;

{$R *.res}


Function InitTestSend:boolean; stdcall;
begin
 result:=GetTestMe.bIsTestSend;
end;

Function Run1:boolean; stdcall;
begin
 if GetTestMe.bIsTestSend then
  result:= GetTestMe.ITestSend.Ok('Dll Fun-1')
 else
  result:= False;
end;
Function Run2:Boolean; stdcall;
begin
 if GetTestMe.bIsTestSend then
  result:= GetTestMe.ITestSend.Ok('Dll Fun-2')
 else
  result:= False;
end;

exports
 InitTestSend
 ,Run1,Run2;

begin
end.
