unit Unit3;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

 type
  TFunctionDLL=Function:boolean; stdcall;


type
  TForm3 = class(TForm)
    btn_DLL_Run1: TButton;
    btn_DLL_RUN2: TButton;
    mmo_1: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btn_DLL_Run1Click(Sender: TObject);
    procedure btn_DLL_RUN2Click(Sender: TObject);
  private
    { Private declarations }
    F_hDLL:THandle;
    F_pRun1,F_pRun2:TFunctionDLL;
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}



procedure TForm3.btn_DLL_Run1Click(Sender: TObject);
begin
    if (@F_pRun1<>nil) and F_pRun1 then
      mmo_1.Lines.Add('Run-1 - OK')
    else
      mmo_1.Lines.Add('Run-1 - ERROR');
end;

procedure TForm3.btn_DLL_RUN2Click(Sender: TObject);
begin
    if (@F_pRun2<>nil) and F_pRun2 then
      mmo_1.Lines.Add('Run-2 - OK')
    else
      mmo_1.Lines.Add('Run-2 - ERROR');

end;

procedure TForm3.FormCreate(Sender: TObject);
var init:TFunctionDLL;
begin
 F_hDLL:=LoadLibrary('DLLTestSend');
 if F_hDLL=0 then Exit;
   @init:= GetProcAddress(F_hDLL, 'InitTestSend');
   if @init<>nil then
    if init then
      mmo_1.Lines.Add('Load TestSend - OK')
    else
      mmo_1.Lines.Add('Load TestSend - ERROR');

   @F_pRun1 := GetProcAddress(F_hDLL, 'Run1');
   @F_pRun2 := GetProcAddress(F_hDLL, 'Run2');


   Caption:='DLLTestSend PID: '+IntToStr(GetCurrentProcessId);

end;

procedure TForm3.FormDestroy(Sender: TObject);
begin
 if F_hDLL<>0 then
  freeLibrary(F_hDLL);
end;

end.
