unit Unit1;
interface
uses
  Winapi.Windows,Winapi.Messages,System.SysUtils,System.Variants,System.Classes,Vcl.Graphics,Vcl.Controls,Vcl.Forms,Vcl.Dialogs
{$REGION '<TESTME>'}      {$IFDEF TESTME}
  ,TestMe,TestMe_Types
  ,TestCodeType,TestCodeLevelUnits
     {$ENDIF}  {$ENDREGION}
  , Vcl.StdCtrls, Vcl.Samples.Spin
  ;
type
  TForm1 = class(TForm)
    se_A: TSpinEdit;
    se_B: TSpinEdit;
    lbl_1: TLabel;
    lbl_Result: TLabel;
    btn_Res: TButton;
    procedure btn_ResClick(Sender: TObject);
  private
{$REGION '<TESTME>'}      {$IFDEF TESTME}
    class var F_pIndexClass:TPIndexValue;
    class Procedure _RegisterMethod;
    class Function _TestMethods( IMethod:IRunMethodParam):TTestResultParam;
{$ENDIF}  {$ENDREGION}
  public
    Function Divide(iA,iB:integer):integer;
  end;
var
  Form1: TForm1;
implementation
{$R *.dfm}
procedure TForm1.btn_ResClick(Sender: TObject);
begin
 lbl_Result.Caption:=IntToStr(Divide(se_A.Value,se_B.Value))
end;
function TForm1.Divide(iA, iB: integer): integer;
begin
 result:=iA div iB;
end;
{$REGION '<TESTME>'}      {$IFDEF TESTME}
type
   TTestMethod = (tmDiv);

class procedure TForm1._RegisterMethod;
begin
 if not GetTestMe.bIsTestCode then  Exit;
 with GetTestMe.ITestCode do begin
  if not ISetDefaultIndClassUnitApp(F_pIndexClass) then exit; // Set position

   IRegisterMethod(tmDiv  ,'tmDiv'  ,'Test Div operation');// Test methods
    IRegisterMethodParams([15,5],[3],'15 div 5=3'); // True result
    IRegisterMethodParams([2,2],[1],'2 div 2=1');   // True result
    IRegisterMethodParams([4,4],[4],'4 div 4<>4 True=Error'); // Error
    IRegisterMethodParams([4,4],[4],'4 div 4=4 trError it''s Ok',trError); // Error = Ok
    IRegisterMethodParams([4,0],[4],'4 div 0 (!) Exception'); // Exception
    IRegisterMethodParams([4,0],[4],'4 div 0 (!) trException it''s Ok',trException); // Exception = Ok
 end; //withend;
end;

class function TForm1._TestMethods(IMethod: IRunMethodParam): TTestResultParam;
begin
 case TTestMethod(IMethod.IGetNumParamUser)  of
    tmDiv: begin
             if (Form1.divide(IMethod.IGetArrParam(0).AsInteger,IMethod.IGetArrParam(1).AsInteger)
               =
                IMethod.IGetArrResultForTestMethod(0).AsInteger) then
              result:=trOk
             else
              result:=trError;
           end;
  end; // case
end;

initialization
   if  GetTestMe.bIsTestCode then begin
     with GetTestMe.ITestCode do begin
       TForm1.F_pIndexClass := IRegisterClass(TForm1._RegisterMethod,TForm1._TestMethods,'TForm1','Main form');
     end;
  end;
{$ENDIF}  {$ENDREGION}
end.
