unit frmMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls
{$REGION '<TESTME>'}      {$IFDEF TESTME}
     ,TestMe,TestMe_Types
     ,TestCodeType,TestCodeLevelUnits
     {$ENDIF}  {$ENDREGION}
  ;

type
  TForm1 = class(TForm)
    lbl_1: TLabel;
{$REGION '<TESTME>'}     {$IFDEF TESTME}
        private
         class Procedure _RegisterMethod; // Register TestMethods
         class  Function _TestMethods( IMethod:IRunMethodParam    // Test Methods
                            ):TTestResultParam;// Result Test
     {$ENDIF}  {$ENDREGION}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

{$REGION '<TESTME>'}     {$IFDEF TESTME}
{ TParamCheck }




  type
     TTestMethod=(
     tmString
    ,tmIntExt
    ,tmObjInterface
    ,tmVariantSetBool
    ,tmBuff
     );


  TTypeTest=(ts1,ts2,ts3,ts4);
  TTypeTestSet=set of TTypeTest;

 var
 L_pIndexClass:TPIndexValue;
 arrBuff:array[0..19] of Integer;

{ TForm1 }

class procedure TForm1._RegisterMethod;
 var
 sShort:ShortString;
 s10:String[10];
  sA:AnsiString;
   pA:PAnsiChar;
  sW:WideString;
  pW:PWideChar;
  sU,sU2:UnicodeString;
    S,s2:string;

  WC:WideChar;
  SS:TTypeTestSet;

     AC1:AnsiChar;
     sAnsi:AnsiString;
  v1,v2,v3:Variant;
  II:IRegisterTestCode;
 dt:TDateTime;
 i:Integer;
begin
  if not GetTestMe.ITestCode.ISetDefaultIndClassUnitApp(L_pIndexClass) then exit; // Set position

   GetTestMe.ITestCode.IRegisterMethod(tmString,'  ');
     // Char
         AC1:='z';
         WC:='Z';

     //ShortString
          sShort:='ABba';
          s10:='Bobda';
     // AnsiString
         sA:='0123456789';
          pA:=PAnsiChar(sA);
     // WideString
          sW:='0123456789';
          pW:=PWideChar(sW);
     // UnicodeString
         sU:='UNICODE - Local string';
     // Default string type
         s:='STRING-NORMAL - Local string';

          sU2:='0123456789';
          s2:= '0123456789';

        // NILL terminate char
          sShort[2]:=#0;
          s10[2]:=#0;
          sA[4]:=#0;
          sW[4]:=#0;
          sU[5]:=#0;
          s[5]:=#0;


      GetTestMe.ITestCode.IRegisterMethodParams([
      // char
         AC1,WC      // 1 2
     //ShortString
       ,sShort,s10 // 3-4-5-6
     // AnsiString
       ,sA,pA      // 7-8
     // WideString
       ,sW,pW      // 9-10
     // UnicodeString
       ,sU,sU2     // 11-12
     // Default string type
       ,s,s2       // 13-14
       ],[],'StringTypes:Short-Ansi-Wide-Unicode Convert',trOk,False);


   GetTestMe.ITestCode.IRegisterMethod(tmIntExt,'Numbers');

         dt:=StrToDateTime('01.01.2019 15:16:17');

      GetTestMe.ITestCode.IRegisterMethodParams([
        //0..4 Integer
         1,$FF,$FFFF,$FFFFFF,$FFFFFFFF
       //5..6 Int64
        ,$FFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
         //7..9 Currency  -> Extended
         ,123.1234,123.123,123.1
         //10..11 Extended
          ,0.123456789012346,123.123456789012
         //12 DateTime
         ,dt
         // 13 - recurring decimal
         ,2/3
        ]
        ,[],'Check numbers Int,Int64,Ext,Date');

        // interface
         II:=GetTestMe.ITestCode;
        // fill buff
        for i := 0 to High(arrBuff) do
        arrBuff[i]:=i;


   GetTestMe.ITestCode.IRegisterMethod(tmObjInterface,'tmRegVarType_ObjInterface ');
      GetTestMe.ITestCode.IRegisterMethodParams([
        //0..2 Pointer,Object,Class
         Pointer(Form1),Form1,TForm1
        //3 Interface
         ,II
         //global buff
         ,@arrBuff
        ]
        ,[],'Check Ponter,Object,Class,Interface');

   GetTestMe.ITestCode.IRegisterMethod(tmVariantSetBool,'tmRegVarType_VariantSetBool ');
   // support variant disabled
             v1:=123;
             v2:='456a';
             v3:='6+10';
         SS:=[ts1,ts3];
      GetTestMe.ITestCode.IRegisterMethodParams([
         //0..1 Boolean
         True,False
        //2..4 Variant
      ,v1,v2,v3
        //5 SETS
           ,Conv_Set2int64(SS,SizeOf(SS))
        ]
        ,[],'Check Variant Set Bool');

   GetTestMe.ITestCode.IRegisterMethod(tmBuff,'tmRegBuff');
   sAnsi:='Buffer-Ansi - Local string';
   sAnsi[3]:=#0;
      GetTestMe.ITestCode.IRegisterMethodParamsBuff([],[],pAnsichar(sAnsi),Length(sAnsi),nil,0,'Buff sAnsi[3]:=#0',trOk,False);

        II:=nil;
end;

class function TForm1._TestMethods(IMethod: IRunMethodParam): TTestResultParam;
   var
  sW:WideString;
  pW:PWideChar;
  SS,SS2:TTypeTestSet;

  sU:UnicodeString;
     sAnsi,sAnsi2,sA:AnsiString;
     pA:PAnsiChar;
  II:IRegisterTestCode;
  II2:IInterface;
  I,i2,i3: Integer;

 iV:Integer;
 i64:Int64;
 c:Currency;
 dt,dt2:TDateTime;
 ex:Extended;
 b:Boolean;
 sShort:ShortString;
 psShort:PShortString;
 s:string;
 pS:PString;
 iNoWarm:Integer;
begin
  if IMethod.INeedBreakTest then begin
    result:=trBreakTest;
    Exit;
  end;
 result:=trNone;

  case TTestMethod(IMethod.IGetNumParamUser)  of
     tmString :
       begin
         IMethod.IAutoConvertParam:=True;
        for I := 0 to IMethod.IGetArrParamCount-1 do begin
           sShort:=IMethod_AsAnsiString(IMethod.IGetArrParam(i));
           psShort:=PShortString(IMethod_AsAnsiString(IMethod.IGetArrParam(i)));
            sA:=IMethod_AsAnsiString(IMethod.IGetArrParam(i));
            pA:=PAnsiChar(IMethod_AsAnsiString(IMethod.IGetArrParam(i)));
           sW:=IMethod_AsWideString(IMethod.IGetArrParam(i));
           pW:=PWideChar(IMethod_AsWideString(IMethod.IGetArrParam(i)));
           sU:=IMethod_AsUnicodeString(IMethod.IGetArrParam(i));
           s:=IMethod_AsUnicodeString(IMethod.IGetArrParam(i));
           pS:=PString(IMethod_AsUnicodeString(IMethod.IGetArrParam(i)));
//           iNoWarm:=ord(pS^[1])+ord(pW[1])+ord(pA[1])+ord(psShort^[1]);

         if  (CompareStr(sShort,sShort)<>0)
          //  OR (CompareStr(sA,pA)<>0)
          //  OR (CompareStr(sW,pW)<>0)
            OR (CompareStr(sU,s)<>0)
         then begin
          Result:=trErrRegister;
          Exit;
         end;
        end;
         // test copy
            SetLength(sA,20);
            SetLength(sW,20);
            SetLength(sU,20);
            SetLength(s,20);
            ZeroMemory(Pointer(sA),20);
            ZeroMemory(Pointer(sW),40);
            ZeroMemory(Pointer(sU),40);
            ZeroMemory(Pointer(s),40);
            for i := 0 to IMethod.IGetArrParamCount-1 do begin
               if (IMethod.IGetArrParam(i).AsType=tdsAnsiString) and (IMethod.IGetArrParam(i).AsAnsiString_GetSize=10) then
               begin
                i2:=IMethod.IGetArrParam(i).AsAnsiString_GetData(sA[1],1);
                i3:=IMethod.IGetArrParam(i).AsAnsiString_GetData(sA[2],10,9);
                b:=(i2<>1) or (i3<>1) or (sA[1]<>'0') or (sA[2]<>'9');
                if b then begin
                 Result:=trErrRegister;
                 Exit;
                end;
               end;

             //sW:='0123456789`';
             //sA:='0123456789';
               if (IMethod.IGetArrParam(i).AsType=tdsWideString) and (IMethod.IGetArrParam(i).AsWideString_GetSize=10) then
               begin
                i2:=IMethod.IGetArrParam(i).AsWideString_GetData(sW[1],1);
                i3:=IMethod.IGetArrParam(i).AsWideString_GetData(sW[2],10,9);
                b:= (i2<>1) or (i3<>1) or (sW[1]<>'0') or (sW[2]<>'9');
                if b then begin
                 Result:=trErrRegister;
                 Exit;
                end;
               end;

             //sA:='0123456789';
               if (IMethod.IGetArrParam(i).AsType=tdsUnicodeString) and (IMethod.IGetArrParam(i).AsUnicodeString_GetSize=10) then
               begin
                i2:=IMethod.IGetArrParam(i).AsUnicodeString_GetData(sU[1],1);
                i3:=IMethod.IGetArrParam(i).AsUnicodeString_GetData(sU[2],10,9);
                b:=(i2<>1) or (i3<>1) or (sU[1]<>'0') or (sU[2]<>'9');
                if b then begin
                 Result:=trErrRegister;
                 Exit;
                end;
               end;

             //sA:='0123456789';
               if (IMethod.IGetArrParam(i).AsType=tdsUnicodeString) and (IMethod.IGetArrParam(i).AsUnicodeString_GetSize=10) then
               begin
                i2:=IMethod.IGetArrParam(i).AsUnicodeString_GetData(s[1],1);
                i3:=IMethod.IGetArrParam(i).AsUnicodeString_GetData(s[2],10,9);
                b:=(i2<>1) or (i3<>1) or (s[1]<>'0') or (s[2]<>'9');
                if b then begin
                 Result:=trErrRegister;
                 Exit;
                end;
               end;
            end;
         result:=trOk;
       end;
     tmIntExt:
     begin
         IMethod.IAutoConvertParam:=False;
        //0..4 Integer
        // 1,$FF,$FFFF,$FFFFFF,$FFFFFFFF
        iV:=-1;
        for I := 0 to 4 do begin
         if tdsInteger<>IMethod.IGetArrParam(i).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         case i of
          0: iV:=1;
          1: iV:=$FF;
          2: iV:=$FFFF;
          3: iV:=$FFFFFF;
          4: iV:=$FFFFFFFF;
         end;
             if IMethod.IGetArrParam(i).AsInteger<>iV then begin
              Result:=trErrRegister;
              Exit;
             end;
        end;
       //5..6 Int64
       // ,$FFFFFFFFFFFF,$FFFFFFFFFFFFFFFF
       i64:=-9;
        for I := 5 to 6 do begin
         if tdsInt64<>IMethod.IGetArrParam(i).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         case i of
          5:i64:=$FFFFFFFFFFFF;
          6:i64:=$FFFFFFFFFFFFFFFF;
         end;
             if IMethod.IGetArrParam(i).AsInt64<>i64 then begin
              Result:=trErrRegister;
              Exit;
             end;
        end;

         //7..9 Currency ->AsExtended
         //,123.1234,123.123,123.1
         c:=0;
        for I := 7 to 9 do begin
         if tdsExtended<>IMethod.IGetArrParam(i).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         case i of
          7:c:=123.1234;
          8:c:=123.123;
          9:c:=123.1;
         end;
             if IMethod.IGetArrParam(i).AsExtended<>c then begin
              Result:=trErrRegister;
              Exit;
             end;
        end;

         //10..11 Extended
         ex:=0;
        for I := 10 to 11 do begin
         if tdsExtended<>IMethod.IGetArrParam(i).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         case i of
          10:ex:=0.123456789012346;
          11:ex:=123.123456789012;
         end;
             if IMethod.IGetArrParam(i).AsExtended<>ex then begin
              Result:=trErrRegister;
              Exit;
             end;
        end;


         //12 DateTime
         //,StrToDate('01.01.2019 15:16:17');
         if tdsExtended<>IMethod.IGetArrParam(12).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         dt:=StrToDateTime('01.01.2019 15:16:17');
         dt2:=IMethod.IGetArrParam(12).AsDateTime;
             if dt<>dt2 then begin
              Result:=trErrRegister;
              Exit;
             end;

       // 13.
       // ,2/3
         if tdsExtended<>IMethod.IGetArrParam(13).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
          // 0,666666666666667
         ex:=0.666666666666667;
             if ex<>IMethod.IGetArrParam(13).AsExtended then begin
              Result:=trErrRegister;
              Exit;
             end;
         result:=trOk;
     end;
   tmObjInterface:
     begin
         IMethod.IAutoConvertParam:=False;


        //1..3 Pointer,Object,Class
        // Pointer(Form1),Form1,TForm1
         if tdsPointer<>IMethod.IGetArrParam(0).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
             if Pointer(Form1)<>IMethod.IGetArrParam(0).AsPointer then begin
              Result:=trErrRegister;
              Exit;
             end;

         if tdsObject<>IMethod.IGetArrParam(1).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
             if Form1<>IMethod.IGetArrParam(1).AsObject then begin
              Result:=trErrRegister;
              Exit;
             end;

         if tdsClass<>IMethod.IGetArrParam(2).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
             if TForm1<>IMethod.IGetArrParam(2).AsClass then begin
              Result:=trErrRegister;
              Exit;
             end;
        //4 Interface
        // ,II
         if tdsInterface<>IMethod.IGetArrParam(3).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         ii2:=IMethod.IGetArrParam(3).AsInterface;
             if II2=nil then begin
              Result:=trErrRegister;
              Exit;
             end;
         ii2.QueryInterface(IRegisterTestCode,II);
             if II=nil then begin
              Result:=trErrRegister;
              Exit;
             end;


         result:=trOk;
     end;
   tmVariantSetBool:
     begin
         result:=trError;
         IMethod.IAutoConvertParam:=False;

         //1..2 Boolean
         //,True,False
         b:=False;
        for I := 0 to 1 do begin
         if tdsBoolean<>IMethod.IGetArrParam(i).AsType then begin
         //  Result:=trErrParamType;
           Exit;
         end;
         case i of
          0:b:=True;
          1:b:=False;
         end;
         //  
             if IMethod.IGetArrParam(i).AsBoolean<>b then begin
              Result:=trErrRegister;
              Exit;
             end;
        end;

        (* Variant UnSupported
        //3..5 tmVariant
        //,v1,v2,v3
        for I := 2 to 4 do begin
         if tdsVariant<>IMethod.IGetArrParam(i).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         case i of
          2:v12:=123;
          3:v12:='456a';
          4:v12:='6+10';
         end;
             if IMethod.IGetArrParam(i).AsVariant<>v12 then begin
           //   Result:=trErrRegister;
              Exit;
             end;
        end;
        *)
        //6 tmRM_SETS_New
        //   ,Conv_Set2int64(SS,SizeOf(SS))//,[ord(ts1),ord(ts3)],'SS:=[ts1,ts3];');
        SS2:=[ts1,ts3];
         if tdsInt64<>IMethod.IGetArrParam(5).AsType then begin
           Result:=trErrParamType;
           Exit;
         end;
         Conv_int642Set(IMethod.IGetArrParam(5).AsInt64,SS,SizeOf(SS));
             if SS<>SS2 then begin
              Exit;
             end;
         result:=trOk;
     end;
    tmBuff:
      begin
       sAnsi2:='Buffer-Ansi - Local string';
         sAnsi2[3]:=#0;

        SetLength(sAnsi,IMethod.IGetArrParamBuff.AsBuff_Size);
        IMethod.IGetArrParamBuff.AsBuff_Data(sAnsi[1],20,1);
        if (sAnsi[2]<>#0) or (sAnsi[7]<>'A') then begin
           result:=trError;
           Exit;
        end;
         result:=trOk;
      end;
  end;

end;


initialization
if GetTestMe.bIsTestCode then begin
  L_pIndexClass:=GetTestMe.ITestCode.IRegisterClass(TForm1._RegisterMethod,TForm1._TestMethods,'TParamCheck','ltTest_TestMe');
end;

     {$ENDIF}  {$ENDREGION}

end.
