unit Calc;

interface
   uses  Classes,SysUtils,db
{$REGION '<TESTME>'}      {$IFDEF TESTME}
     ,TestMe,TestMe_Types
     ,TestCodeType,TestCodeLevelUnits
     ,Vcl.Dialogs
     {$ENDIF}  {$ENDREGION}
     ;
      type
       TCalc=class
{$REGION '<TESTME>'}     {$IFDEF TESTME}
        private
         class Procedure _RegisterMethod; // Register TestMethods
         class  Function _TestMethods( IMethod:IRunMethodParam    // Test Methods
                            ):TTestResultParam;// Result Test
     {$ENDIF}  {$ENDREGION}
        private
        public
         class function Plus(iA,iB:integer):integer;
       end;

implementation

{ TCalc }


class function TCalc.Plus(iA,iB: integer): integer;
begin
 result:=iA+iB;
end;

{$REGION '<TESTME>'} {$IFDEF TESTME}
 var
//  L_IRegTestMe:IRegisterTestMe;
  L_pIndexUnit,L_pIndexApp
   ,L_pIndexTCalculate:TPIndexValue;

   L_oCalc:TCalc;

    Type
     TTestMethod=(
      tmPlus
     );



class procedure TCalc._RegisterMethod;
begin
 if GetTestMe.bIsTestCode then begin
  with GetTestMe.ITestCode do begin
   // Set position
   if not ISetDefaultIndClassUnitApp(L_pIndexTCalculate,L_pIndexUnit,L_pIndexApp) then Exit;

 // Test methods
   IRegisterMethod(tmPlus  ,'tmPlus'  ,'Test Plus operation');
    IRegisterMethodParams([2,2],[4],'2+2=4');
    IRegisterMethodParams([5,5],[10],'5+5=10');
    IRegisterMethodParams([4,4],[4],'4+4=4 trError it''s Ok',trError);
  end;
 end;

end;


class function TCalc._TestMethods(
  IMethod: IRunMethodParam): TTestResultParam;
begin
  Result:=trNone; // No WARN
 case TTestMethod(IMethod.IGetNumParamUser)  of
   tmPlus :begin
           if TCalc.Plus(IMethod.IGetArrParam(0).AsInteger,IMethod.IGetArrParam(1).AsInteger)= IMethod.IGetArrResultForTestMethod(0).AsInteger then
            result:=trOk
           else
            result:=trError;
     end;
 end;
end;

initialization

if GetTestMe.bIsTestCode then begin
  with GetTestMe.ITestCode do begin
    L_pIndexApp:=IRegisterApplication(hInstance);
    L_pIndexUnit:=IRegisterUnit(ltMyComponenst,'Calculator','unit Calculator components');
    L_pIndexTCalculate   := IRegisterClass(TCalc._RegisterMethod,TCalc._TestMethods,'TCalc','Class Calculater');
  end;
end else begin
  ShowMessage('Not find  TestMeDllxx.dll');
end;

{$ENDIF} {$ENDREGION}


end.
