unit Unit1;
 {$IFNDEF TestSEND}
   set define condition - TestSEND
 {$ENDIF}

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Samples.Spin;

type
  TForm1 = class(TForm)
    grp_SendMe: TGroupBox;
    bvl1: TBevel;
    bvl2: TBevel;
    lbl_Add: TLabel;
    lbl_Text: TLabel;
    lbl_Value: TLabel;
    lbl_Step: TLabel;
    lbl_Level: TLabel;
    lbl_Status: TLabel;
    Label1: TLabel;
    lbl_StatText: TLabel;
    lbl_StatFast: TLabel;
    Label2: TLabel;
    lbl_StatTextIf: TLabel;
    lbl_1: TLabel;
    btn_Send: TButton;
    rg_Normal: TRadioGroup;
    rg_IF: TRadioGroup;
    rg_Fast: TRadioGroup;
    edt_Msg: TEdit;
    se_Value: TSpinEdit;
    se_Step: TSpinEdit;
    se_Level: TSpinEdit;
    btn_SendFast: TButton;
    btn_SendIF: TButton;
    edt_PID: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure btn_SendClick(Sender: TObject);
    procedure btn_SendIFClick(Sender: TObject);
    procedure btn_SendFastClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
 uses
  TestMe,TestMe_Types
  ,TestSendType
  ;

{$R *.dfm}

var L_pTestMe:PTRecITestMe;

procedure TForm1.FormCreate(Sender: TObject);
begin
 L_pTestMe:=GetTestMe;
 edt_PID.Text:=IntToStr(GetCurrentProcessId);
 Caption:='TestSend_OneApp  PID: '+edt_PID.Text;

end;

procedure TForm1.btn_SendClick(Sender: TObject);
 var b:Boolean;
begin
 lbl_StatText.Caption:=' - - -'; Application.ProcessMessages;
 if L_pTestMe.ITestSend=nil then Exit;
 b:=False; // init
 with L_pTestMe.ITestSend do begin
   case rg_Normal.ItemIndex of
    0: b:=Text(edt_Msg.Text,se_Step.Value,se_Level.Value);
    1: b:=Info(edt_Msg.Text,se_Step.Value,se_Level.Value);
    2: b:=Confirm(edt_Msg.Text,se_Step.Value,se_Level.Value);
    3: b:=Warning(edt_Msg.Text,se_Step.Value,se_Level.Value);
    4: b:=Error(edt_Msg.Text,se_Step.Value,se_Level.Value);
    5: b:=Ok(edt_Msg.Text,se_Step.Value,se_Level.Value);
    6: b:=True(edt_Msg.Text,se_Step.Value,se_Level.Value);
    7: b:=False(edt_Msg.Text,se_Step.Value,se_Level.Value);
    8: //< All >
     begin
        b:=System.True;
        b:=b and Text(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Info(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Confirm(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Warning(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Error(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Ok(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and True(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and False(edt_Msg.Text,se_Step.Value,se_Level.Value);
     end;
   end; // case
 end; //with
  if b then
   lbl_StatText.Caption:='OK'
  else
   lbl_StatText.Caption:='Error';

end;


procedure TForm1.btn_SendFastClick(Sender: TObject);
 var b:Boolean;
begin
 lbl_StatTextIf.Caption:=' - - -'; Application.ProcessMessages;
 if L_pTestMe.ITestSend=nil then Exit;
 case rg_Fast.ItemIndex of
  0:b:=L_pTestMe.ITestSend.FastValue(se_Value.Value,se_Step.Value,se_Level.Value);
  1:b:=L_pTestMe.ITestSend.FastValue_If(se_Value.Value,se_Step.Value,se_Level.Value);
 end;
  if b then
   lbl_StatFast.Caption:='OK'
  else
   lbl_StatFast.Caption:='Error';
end;

procedure TForm1.btn_SendIFClick(Sender: TObject);
 var b:Boolean;
begin
 lbl_StatTextIf.Caption:=' - - -'; Application.ProcessMessages;
 if L_pTestMe.ITestSend=nil then Exit;
 b:=False; // init
 with L_pTestMe.ITestSend do begin
   case rg_IF.ItemIndex of
    0: b:=Text_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    1: b:=Info_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    2: b:=Confirm_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    3: b:=Warning_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    4: b:=Error_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    5: b:=Ok_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    6: b:=True_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    7: b:=False_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
    8: //< All >
     begin
        b:=System.True;
        b:=b and Text_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Info_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Confirm_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Warning_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Error_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and Ok_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and True_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
        b:=b and False_If(edt_Msg.Text,se_Step.Value,se_Level.Value);
     end;
   end; // case
 end; //with

  if b then
   lbl_StatTextIf.Caption:='OK'
  else
   lbl_StatTextIf.Caption:='Error';

end;

end.


